# coding: utf-8


"""
IGNORE:
    Nutanix IAM Versioned APIs

    Nutanix APIs for managing users, user-groups, directory services, identity providers, roles and authorization policies.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path

class DirectoryServiceSearchQuery(object):

    """Information for directory search query.

    :param query: (:attr:`query`) Query string for directory service search.
    :type query: required
     max=2000 chars
    
    :param searched_attributes: (:attr:`searched_attributes`) Attributes for search operation. By default, the search will be performed with a common name.
    :type searched_attributes: 
    
    
    :param returned_attributes: (:attr:`returned_attributes`) Attributes returned by the search operation.
    :type returned_attributes: 
    
    
    :param is_wildcard_search: (:attr:`is_wildcard_search`) Flag indicating whether the search should be a wildcard search or not. (**Default** True)
    :type is_wildcard_search: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'query': 'str',
        'searched_attributes': 'list[str]',
        'returned_attributes': 'list[str]',
        'is_wildcard_search': 'bool',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'query': 'query',
        'searched_attributes': 'searchedAttributes',
        'returned_attributes': 'returnedAttributes',
        'is_wildcard_search': 'isWildcardSearch',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, query=None, searched_attributes=None, returned_attributes=None, is_wildcard_search=True, *args, **kwargs):  # noqa: E501
        self.__query = None
        self.__searched_attributes = None
        self.__returned_attributes = None
        self.__is_wildcard_search = None
        self.discriminator = None
        self.__query = query
        if searched_attributes is not None:
            self.__searched_attributes = searched_attributes
        if returned_attributes is not None:
            self.__returned_attributes = returned_attributes
        if is_wildcard_search is not None:
            self.__is_wildcard_search = is_wildcard_search
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'iam.v4.authn.DirectoryServiceSearchQuery'

    def _initialize_object_version(self):
        return 'v4.r0'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def query(self):
        """
        Query string for directory service search.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__query

    @query.setter
    def query(self, query):
        if query is None:
            raise ValueError("Invalid value for `query`, must not be `None`")  # noqa: E501
        if query is not None and len(query) > 2000:
            raise ValueError("Invalid value for `query`, length must be less than or equal to `2000`")  # noqa: E501

        self.__query = query

    @property
    def searched_attributes(self):
        """
        Attributes for search operation. By default, the search will be performed with a common name.

        :type:
            list[ :class:`~str` ]
        """  # noqa: E501
        return self.__searched_attributes

    @searched_attributes.setter
    def searched_attributes(self, searched_attributes):

        self.__searched_attributes = searched_attributes

    @property
    def returned_attributes(self):
        """
        Attributes returned by the search operation.

        :type:
            list[ :class:`~str` ]
        """  # noqa: E501
        return self.__returned_attributes

    @returned_attributes.setter
    def returned_attributes(self, returned_attributes):

        self.__returned_attributes = returned_attributes

    @property
    def is_wildcard_search(self):
        """
        Flag indicating whether the search should be a wildcard search or not.

        :type:
                :class:`~bool`
        """  # noqa: E501
        return self.__is_wildcard_search

    @is_wildcard_search.setter
    def is_wildcard_search(self, is_wildcard_search):

        self.__is_wildcard_search = is_wildcard_search

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(DirectoryServiceSearchQuery, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DirectoryServiceSearchQuery):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

