# coding: utf-8


"""
IGNORE:
    Nutanix IAM Versioned APIs

    Nutanix APIs for managing users, user-groups, directory services, identity providers, roles and authorization policies.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_iam_py_client.models.iam.v4.authn.CreationType import CreationType  # noqa: F401,E501
from ntnx_iam_py_client.models.iam.v4.authn.UserType import UserType  # noqa: F401,E501

class SecretKeyResponse(object):

    """IAM secret key response.

    :param secret_access_key: (:attr:`secret_access_key`) This represents secret access key, which will be returned only during access key creation.
    :type secret_access_key: required
    
    
    :param email_id: (:attr:`email_id`) Email ID of the user.
    :type email_id: required
     max=255 chars
    
    :param user_id: (:attr:`user_id`) User identifier who owns the bucket access key.
    :type user_id: required
    
    
    :param user_type: (:attr:`user_type`) 
    :type user_type: required
    
    
    :param tenant_id: (:attr:`tenant_id`) ID of tenant for which configuration is being set up.
    :type tenant_id: required
    
    
    :param idp_id: (:attr:`idp_id`) Identifier of the IDP for the user.
    :type idp_id: required
    
    
    :param username: (:attr:`username`) Identifier of the user.
    :type username: required
     min=1 chars, max=255 chars
    
    :param creation_type: (:attr:`creation_type`) 
    :type creation_type: required
    
    
    :param custom_claims: (:attr:`custom_claims`) Any additional user attributes obtained from the authentication provider in the form of key/value pairs.
    :type custom_claims: required
    
    
    :param assigned_to: (:attr:`assigned_to`) External client to whom this key is allocated.
    :type assigned_to: required
     min=3 chars, max=255 chars
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'secret_access_key': 'str',
        'email_id': 'str',
        'user_id': 'str',
        'user_type': 'iam.v4.authn.UserType',
        'tenant_id': 'str',
        'idp_id': 'str',
        'username': 'str',
        'creation_type': 'iam.v4.authn.CreationType',
        'custom_claims': 'dict(str, str)',
        'assigned_to': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'secret_access_key': 'secretAccessKey',
        'email_id': 'emailId',
        'user_id': 'userId',
        'user_type': 'userType',
        'tenant_id': 'tenantId',
        'idp_id': 'idpId',
        'username': 'username',
        'creation_type': 'creationType',
        'custom_claims': 'customClaims',
        'assigned_to': 'assignedTo',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, secret_access_key=None, email_id=None, user_id=None, user_type=None, tenant_id=None, idp_id=None, username=None, creation_type=None, custom_claims=None, assigned_to=None, *args, **kwargs):  # noqa: E501
        self.__secret_access_key = None
        self.__email_id = None
        self.__user_id = None
        self.__user_type = None
        self.__tenant_id = None
        self.__idp_id = None
        self.__username = None
        self.__creation_type = None
        self.__custom_claims = None
        self.__assigned_to = None
        self.discriminator = None
        self.__secret_access_key = secret_access_key
        self.__email_id = email_id
        self.__user_id = user_id
        self.__user_type = user_type
        self.__tenant_id = tenant_id
        self.__idp_id = idp_id
        self.__username = username
        self.__creation_type = creation_type
        self.__custom_claims = custom_claims
        self.__assigned_to = assigned_to
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'iam.v4.authn.SecretKeyResponse'

    def _initialize_object_version(self):
        return 'v4.r0'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def secret_access_key(self):
        """
        This represents secret access key, which will be returned only during access key creation.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__secret_access_key

    @secret_access_key.setter
    def secret_access_key(self, secret_access_key):
        if secret_access_key is None:
            raise ValueError("Invalid value for `secret_access_key`, must not be `None`")  # noqa: E501

        self.__secret_access_key = secret_access_key

    @property
    def email_id(self):
        """
        Email ID of the user.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__email_id

    @email_id.setter
    def email_id(self, email_id):
        if email_id is None:
            raise ValueError("Invalid value for `email_id`, must not be `None`")  # noqa: E501
        if email_id is not None and len(email_id) > 255:
            raise ValueError("Invalid value for `email_id`, length must be less than or equal to `255`")  # noqa: E501
        if email_id is not None and not re.search('^([a-zA-Z0-9_\\-\\.]+)@([a-zA-Z0-9_\\-\\.]+)\\.([a-zA-Z]{2,5})$', email_id):  # noqa: E501
            raise ValueError(r"Invalid value for `email_id`, must be a follow pattern or equal to `/^([a-zA-Z0-9_\\-\\.]+)@([a-zA-Z0-9_\\-\\.]+)\\.([a-zA-Z]{2,5})$/`")  # noqa: E501

        self.__email_id = email_id

    @property
    def user_id(self):
        """
        User identifier who owns the bucket access key.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__user_id

    @user_id.setter
    def user_id(self, user_id):
        if user_id is None:
            raise ValueError("Invalid value for `user_id`, must not be `None`")  # noqa: E501

        self.__user_id = user_id

    @property
    def user_type(self):
        """
        

        :type:
            :class:`~ntnx_iam_py_client.models.iam.v4.authn.UserType`
        """  # noqa: E501
        return self.__user_type

    @user_type.setter
    def user_type(self, user_type):
        if user_type is None:
            raise ValueError("Invalid value for `user_type`, must not be `None`")  # noqa: E501

        self.__user_type = user_type

    @property
    def tenant_id(self):
        """
        ID of tenant for which configuration is being set up.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__tenant_id

    @tenant_id.setter
    def tenant_id(self, tenant_id):
        if tenant_id is None:
            raise ValueError("Invalid value for `tenant_id`, must not be `None`")  # noqa: E501
        if tenant_id is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', tenant_id):  # noqa: E501
            raise ValueError(r"Invalid value for `tenant_id`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__tenant_id = tenant_id

    @property
    def idp_id(self):
        """
        Identifier of the IDP for the user.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__idp_id

    @idp_id.setter
    def idp_id(self, idp_id):
        if idp_id is None:
            raise ValueError("Invalid value for `idp_id`, must not be `None`")  # noqa: E501
        if idp_id is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', idp_id):  # noqa: E501
            raise ValueError(r"Invalid value for `idp_id`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__idp_id = idp_id

    @property
    def username(self):
        """
        Identifier of the user.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__username

    @username.setter
    def username(self, username):
        if username is None:
            raise ValueError("Invalid value for `username`, must not be `None`")  # noqa: E501
        if username is not None and len(username) > 255:
            raise ValueError("Invalid value for `username`, length must be less than or equal to `255`")  # noqa: E501
        if username is not None and len(username) < 1:
            raise ValueError("Invalid value for `username`, length must be greater than or equal to `1`")  # noqa: E501
        if username is not None and not re.search('^[^<>;\'()&+%\/\\\\\"`]*$', username):  # noqa: E501
            raise ValueError(r"Invalid value for `username`, must be a follow pattern or equal to `/^[^<>;'()&+%\/\\\\\"`]*$/`")  # noqa: E501

        self.__username = username

    @property
    def creation_type(self):
        """
        

        :type:
            :class:`~ntnx_iam_py_client.models.iam.v4.authn.CreationType`
        """  # noqa: E501
        return self.__creation_type

    @creation_type.setter
    def creation_type(self, creation_type):
        if creation_type is None:
            raise ValueError("Invalid value for `creation_type`, must not be `None`")  # noqa: E501

        self.__creation_type = creation_type

    @property
    def custom_claims(self):
        """
        Any additional user attributes obtained from the authentication provider in the form of key/value pairs.

        :type:
            dict(str, :class:`~str`)
        """  # noqa: E501
        return self.__custom_claims

    @custom_claims.setter
    def custom_claims(self, custom_claims):
        if custom_claims is None:
            raise ValueError("Invalid value for `custom_claims`, must not be `None`")  # noqa: E501

        self.__custom_claims = custom_claims

    @property
    def assigned_to(self):
        """
        External client to whom this key is allocated.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__assigned_to

    @assigned_to.setter
    def assigned_to(self, assigned_to):
        if assigned_to is None:
            raise ValueError("Invalid value for `assigned_to`, must not be `None`")  # noqa: E501
        if assigned_to is not None and len(assigned_to) > 255:
            raise ValueError("Invalid value for `assigned_to`, length must be less than or equal to `255`")  # noqa: E501
        if assigned_to is not None and len(assigned_to) < 3:
            raise ValueError("Invalid value for `assigned_to`, length must be greater than or equal to `3`")  # noqa: E501

        self.__assigned_to = assigned_to

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(SecretKeyResponse, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SecretKeyResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

