# coding: utf-8


"""
IGNORE:
    Nutanix IAM Versioned APIs

    Nutanix APIs for managing users, user-groups, directory services, identity providers, roles and authorization policies.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path

class UserGroupConfiguration(object):

    """User Group configuration for OpenLDAP directory service.

    :param group_object_class: (:attr:`group_object_class`) Object class in the OpenLDAP system that corresponds to groups.
    :type group_object_class: required
     max=64 chars
    
    :param group_search_base: (:attr:`group_search_base`) Base DN for group search.
    :type group_search_base: required
     max=200 chars
    
    :param group_member_attribute: (:attr:`group_member_attribute`) Attribute in a group that associates users to the group.
    :type group_member_attribute: required
     max=64 chars
    
    :param group_member_attribute_value: (:attr:`group_member_attribute_value`) User attribute value that will be used in group entity to associate user to the group.
    :type group_member_attribute_value: required
     max=64 chars
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'group_object_class': 'str',
        'group_search_base': 'str',
        'group_member_attribute': 'str',
        'group_member_attribute_value': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'group_object_class': 'groupObjectClass',
        'group_search_base': 'groupSearchBase',
        'group_member_attribute': 'groupMemberAttribute',
        'group_member_attribute_value': 'groupMemberAttributeValue',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, group_object_class=None, group_search_base=None, group_member_attribute=None, group_member_attribute_value=None, *args, **kwargs):  # noqa: E501
        self.__group_object_class = None
        self.__group_search_base = None
        self.__group_member_attribute = None
        self.__group_member_attribute_value = None
        self.discriminator = None
        self.__group_object_class = group_object_class
        self.__group_search_base = group_search_base
        self.__group_member_attribute = group_member_attribute
        self.__group_member_attribute_value = group_member_attribute_value
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'iam.v4.authn.UserGroupConfiguration'

    def _initialize_object_version(self):
        return 'v4.r0'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def group_object_class(self):
        """
        Object class in the OpenLDAP system that corresponds to groups.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__group_object_class

    @group_object_class.setter
    def group_object_class(self, group_object_class):
        if group_object_class is None:
            raise ValueError("Invalid value for `group_object_class`, must not be `None`")  # noqa: E501
        if group_object_class is not None and len(group_object_class) > 64:
            raise ValueError("Invalid value for `group_object_class`, length must be less than or equal to `64`")  # noqa: E501

        self.__group_object_class = group_object_class

    @property
    def group_search_base(self):
        """
        Base DN for group search.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__group_search_base

    @group_search_base.setter
    def group_search_base(self, group_search_base):
        if group_search_base is None:
            raise ValueError("Invalid value for `group_search_base`, must not be `None`")  # noqa: E501
        if group_search_base is not None and len(group_search_base) > 200:
            raise ValueError("Invalid value for `group_search_base`, length must be less than or equal to `200`")  # noqa: E501

        self.__group_search_base = group_search_base

    @property
    def group_member_attribute(self):
        """
        Attribute in a group that associates users to the group.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__group_member_attribute

    @group_member_attribute.setter
    def group_member_attribute(self, group_member_attribute):
        if group_member_attribute is None:
            raise ValueError("Invalid value for `group_member_attribute`, must not be `None`")  # noqa: E501
        if group_member_attribute is not None and len(group_member_attribute) > 64:
            raise ValueError("Invalid value for `group_member_attribute`, length must be less than or equal to `64`")  # noqa: E501

        self.__group_member_attribute = group_member_attribute

    @property
    def group_member_attribute_value(self):
        """
        User attribute value that will be used in group entity to associate user to the group.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__group_member_attribute_value

    @group_member_attribute_value.setter
    def group_member_attribute_value(self, group_member_attribute_value):
        if group_member_attribute_value is None:
            raise ValueError("Invalid value for `group_member_attribute_value`, must not be `None`")  # noqa: E501
        if group_member_attribute_value is not None and len(group_member_attribute_value) > 64:
            raise ValueError("Invalid value for `group_member_attribute_value`, length must be less than or equal to `64`")  # noqa: E501

        self.__group_member_attribute_value = group_member_attribute_value

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(UserGroupConfiguration, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UserGroupConfiguration):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

