# coding: utf-8


"""
IGNORE:
    Nutanix IAM Versioned APIs

    Nutanix APIs for managing users, user-groups, directory services, identity providers, roles and authorization policies.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_iam_py_client.models.iam.v4.authz.AuthorizationPolicy import AuthorizationPolicy  # noqa: F401,E501
from ntnx_iam_py_client.models.iam.v4.authz.AuthorizationPolicyType import AuthorizationPolicyType  # noqa: F401,E501
from ntnx_iam_py_client.models.iam.v4.authz.IdentityFilter import IdentityFilter  # noqa: F401,E501
from ntnx_iam_py_client.models.iam.v4.authz.RoleProjection import RoleProjection  # noqa: F401,E501

class AuthorizationPolicyProjection(AuthorizationPolicy):

    """

    :param role_projection: (:attr:`role_projection`) 
    :type role_projection: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'role_projection': 'iam.v4.authz.RoleProjection',
        'identities': 'list[iam.v4.authz.IdentityFilter]',
        'created_time': 'datetime',
        'last_updated_time': 'datetime',
        'created_by': 'str',
        'is_system_defined': 'bool',
        'authorization_policy_type': 'iam.v4.authz.AuthorizationPolicyType',
        'assigned_users_count': 'int',
        'assigned_user_groups_count': 'int',
        'display_name': 'str',
        'description': 'str',
        'client_name': 'str',
        'entities': 'list[iam.v4.authz.EntityFilter]',
        'role': 'str',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'role_projection': 'roleProjection',
        'identities': 'identities',
        'created_time': 'createdTime',
        'last_updated_time': 'lastUpdatedTime',
        'created_by': 'createdBy',
        'is_system_defined': 'isSystemDefined',
        'authorization_policy_type': 'authorizationPolicyType',
        'assigned_users_count': 'assignedUsersCount',
        'assigned_user_groups_count': 'assignedUserGroupsCount',
        'display_name': 'displayName',
        'description': 'description',
        'client_name': 'clientName',
        'entities': 'entities',
        'role': 'role',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, role_projection=None, identities=None, created_time=None, last_updated_time=None, created_by=None, is_system_defined=True, authorization_policy_type=None, assigned_users_count=None, assigned_user_groups_count=None, display_name=None, description=None, client_name=None, entities=None, role=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        AuthorizationPolicy.__init__(self, identities, created_time, last_updated_time, created_by, is_system_defined, authorization_policy_type, assigned_users_count, assigned_user_groups_count, display_name, description, client_name, entities, role, ext_id, links, tenant_id, *args, **kwargs)
        self.__role_projection = None
        self.discriminator = None
        if role_projection is not None:
            self.__role_projection = role_projection

    def _initialize_object_type(self):
        return 'iam.v4.authz.AuthorizationPolicyProjection'

    def _initialize_object_version(self):
        return 'v4.r0'


    @property
    def role_projection(self):
        """
        

        :type:
            :class:`~ntnx_iam_py_client.models.iam.v4.authz.RoleProjection`
        """  # noqa: E501
        return self.__role_projection

    @role_projection.setter
    def role_projection(self, role_projection):

        self.__role_projection = role_projection

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(AuthorizationPolicyProjection, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AuthorizationPolicyProjection):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

