# coding: utf-8


"""
IGNORE:
    Nutanix IAM Versioned APIs

    Nutanix APIs for managing users, user-groups, directory services, identity providers, roles and authorization policies.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_iam_py_client.models.common.v1.response.ApiLink import ApiLink  # noqa: F401,E501
from ntnx_iam_py_client.models.common.v1.response.ExternalizableAbstractModel import ExternalizableAbstractModel  # noqa: F401,E501
from ntnx_iam_py_client.models.iam.v4.authz.AttributeEntity import AttributeEntity  # noqa: F401,E501

class Entity(ExternalizableAbstractModel):

    """Information of the entity.

    :param name: (:attr:`name`) Unique name of the entity.
    :type name: 
     min=1 chars, max=255 chars
    
    :param description: (:attr:`description`) Description of the entity.
    :type description: 
     max=1000 chars
    
    :param display_name: (:attr:`display_name`) UI display name of the entity.
    :type display_name: 
     min=1 chars, max=255 chars
    
    :param client_name: (:attr:`client_name`) Name of client the entity belongs to.
    :type client_name: 
     min=1 chars, max=255 chars
    
    :param search_url: (:attr:`search_url`) URL provided by the client to search the entities.
    :type search_url: 
     min=3 chars, max=2000 chars
    
    :param created_time: (:attr:`created_time`) The creation time of the entity.
    :type created_time: 
    
    
    :param last_updated_time: (:attr:`last_updated_time`) The time when the entity was last updated.
    :type last_updated_time: 
    
    
    :param created_by: (:attr:`created_by`) User or Service Name that created the entity.
    :type created_by: 
    
    
    :param attribute_list: (:attr:`attribute_list`) 
    :type attribute_list: 
    
    
    :param is_logical_and_supported_for_attributes: (:attr:`is_logical_and_supported_for_attributes`) Indicates whether the entity supports scoping using multiple attributes which will result in a logical AND.
    :type is_logical_and_supported_for_attributes: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'name': 'str',
        'description': 'str',
        'display_name': 'str',
        'client_name': 'str',
        'search_url': 'str',
        'created_time': 'datetime',
        'last_updated_time': 'datetime',
        'created_by': 'str',
        'attribute_list': 'list[iam.v4.authz.AttributeEntity]',
        'is_logical_and_supported_for_attributes': 'bool',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'name': 'name',
        'description': 'description',
        'display_name': 'displayName',
        'client_name': 'clientName',
        'search_url': 'searchURL',
        'created_time': 'createdTime',
        'last_updated_time': 'lastUpdatedTime',
        'created_by': 'createdBy',
        'attribute_list': 'attributeList',
        'is_logical_and_supported_for_attributes': 'isLogicalAndSupportedForAttributes',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, name=None, description=None, display_name=None, client_name=None, search_url=None, created_time=None, last_updated_time=None, created_by=None, attribute_list=None, is_logical_and_supported_for_attributes=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        ExternalizableAbstractModel.__init__(self, ext_id, links, tenant_id, *args, **kwargs)
        self.__name = None
        self.__description = None
        self.__display_name = None
        self.__client_name = None
        self.__search_url = None
        self.__created_time = None
        self.__last_updated_time = None
        self.__created_by = None
        self.__attribute_list = None
        self.__is_logical_and_supported_for_attributes = None
        self.discriminator = None
        if name is not None:
            self.__name = name
        if description is not None:
            self.__description = description
        if display_name is not None:
            self.__display_name = display_name
        if client_name is not None:
            self.__client_name = client_name
        if search_url is not None:
            self.__search_url = search_url
        if created_time is not None:
            self.__created_time = created_time
        if last_updated_time is not None:
            self.__last_updated_time = last_updated_time
        if created_by is not None:
            self.__created_by = created_by
        if attribute_list is not None:
            self.__attribute_list = attribute_list
        if is_logical_and_supported_for_attributes is not None:
            self.__is_logical_and_supported_for_attributes = is_logical_and_supported_for_attributes

    def _initialize_object_type(self):
        return 'iam.v4.authz.Entity'

    def _initialize_object_version(self):
        return 'v4.r0'


    @property
    def name(self):
        """
        Unique name of the entity.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__name

    @name.setter
    def name(self, name):
        if name is not None and len(name) > 255:
            raise ValueError("Invalid value for `name`, length must be less than or equal to `255`")  # noqa: E501
        if name is not None and len(name) < 1:
            raise ValueError("Invalid value for `name`, length must be greater than or equal to `1`")  # noqa: E501

        self.__name = name

    @property
    def description(self):
        """
        Description of the entity.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__description

    @description.setter
    def description(self, description):
        if description is not None and len(description) > 1000:
            raise ValueError("Invalid value for `description`, length must be less than or equal to `1000`")  # noqa: E501

        self.__description = description

    @property
    def display_name(self):
        """
        UI display name of the entity.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__display_name

    @display_name.setter
    def display_name(self, display_name):
        if display_name is not None and len(display_name) > 255:
            raise ValueError("Invalid value for `display_name`, length must be less than or equal to `255`")  # noqa: E501
        if display_name is not None and len(display_name) < 1:
            raise ValueError("Invalid value for `display_name`, length must be greater than or equal to `1`")  # noqa: E501
        if display_name is not None and not re.search('^[^\\\"]*$', display_name):  # noqa: E501
            raise ValueError(r"Invalid value for `display_name`, must be a follow pattern or equal to `/^[^\\\"]*$/`")  # noqa: E501

        self.__display_name = display_name

    @property
    def client_name(self):
        """
        Name of client the entity belongs to.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__client_name

    @client_name.setter
    def client_name(self, client_name):
        if client_name is not None and len(client_name) > 255:
            raise ValueError("Invalid value for `client_name`, length must be less than or equal to `255`")  # noqa: E501
        if client_name is not None and len(client_name) < 1:
            raise ValueError("Invalid value for `client_name`, length must be greater than or equal to `1`")  # noqa: E501

        self.__client_name = client_name

    @property
    def search_url(self):
        """
        URL provided by the client to search the entities.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__search_url

    @search_url.setter
    def search_url(self, search_url):
        if search_url is not None and len(search_url) > 2000:
            raise ValueError("Invalid value for `search_url`, length must be less than or equal to `2000`")  # noqa: E501
        if search_url is not None and len(search_url) < 3:
            raise ValueError("Invalid value for `search_url`, length must be greater than or equal to `3`")  # noqa: E501
        if search_url is not None and not re.search('^((http[s]?|nfs):\/)?\/?([^:\/\\s]*)((\/\\w+)*(:[0-9]+)*?\/)([\\w\\-\\.]+[^#?\\s]+)(.*)?(#[\\w\\-]+)?$', search_url):  # noqa: E501
            raise ValueError(r"Invalid value for `search_url`, must be a follow pattern or equal to `/^((http[s]?|nfs):\/)?\/?([^:\/\\s]*)((\/\\w+)*(:[0-9]+)*?\/)([\\w\\-\\.]+[^#?\\s]+)(.*)?(#[\\w\\-]+)?$/`")  # noqa: E501

        self.__search_url = search_url

    @property
    def created_time(self):
        """
        The creation time of the entity.

        :type:
                :class:`~datetime`
        """  # noqa: E501
        return self.__created_time

    @created_time.setter
    def created_time(self, created_time):

        self.__created_time = created_time

    @property
    def last_updated_time(self):
        """
        The time when the entity was last updated.

        :type:
                :class:`~datetime`
        """  # noqa: E501
        return self.__last_updated_time

    @last_updated_time.setter
    def last_updated_time(self, last_updated_time):

        self.__last_updated_time = last_updated_time

    @property
    def created_by(self):
        """
        User or Service Name that created the entity.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__created_by

    @created_by.setter
    def created_by(self, created_by):

        self.__created_by = created_by

    @property
    def attribute_list(self):
        """
        

        :type:
             list[ :class:`~ntnx_iam_py_client.models.iam.v4.authz.AttributeEntity` ]
        """  # noqa: E501
        return self.__attribute_list

    @attribute_list.setter
    def attribute_list(self, attribute_list):

        self.__attribute_list = attribute_list

    @property
    def is_logical_and_supported_for_attributes(self):
        """
        Indicates whether the entity supports scoping using multiple attributes which will result in a logical AND.

        :type:
                :class:`~bool`
        """  # noqa: E501
        return self.__is_logical_and_supported_for_attributes

    @is_logical_and_supported_for_attributes.setter
    def is_logical_and_supported_for_attributes(self, is_logical_and_supported_for_attributes):

        self.__is_logical_and_supported_for_attributes = is_logical_and_supported_for_attributes

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(Entity, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Entity):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

