# coding: utf-8


"""
IGNORE:
    Nutanix IAM Versioned APIs

    Nutanix APIs for managing users, user-groups, directory services, identity providers, roles and authorization policies.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_iam_py_client.models.common.v1.response.ApiLink import ApiLink  # noqa: F401,E501
from ntnx_iam_py_client.models.common.v1.response.ExternalizableAbstractModel import ExternalizableAbstractModel  # noqa: F401,E501
from ntnx_iam_py_client.models.iam.v4.authz.AssociatedEndpoint import AssociatedEndpoint  # noqa: F401,E501
from ntnx_iam_py_client.models.iam.v4.authz.OperationType import OperationType  # noqa: F401,E501

class Operation(ExternalizableAbstractModel):

    """

    :param display_name: (:attr:`display_name`) Name of the operation.
    :type display_name: 
     min=1 chars, max=255 chars
    
    :param description: (:attr:`description`) Description of the operation.
    :type description: 
     max=1000 chars
    
    :param entity_type: (:attr:`entity_type`) Type of entity associated with this operation.
    :type entity_type: 
    
    
    :param client_name: (:attr:`client_name`) Client that created the entity.
    :type client_name: 
     max=255 chars
    
    :param created_time: (:attr:`created_time`) The creation time of the operation.
    :type created_time: 
    
    
    :param last_updated_time: (:attr:`last_updated_time`) The time when the operation was last updated.
    :type last_updated_time: 
    
    
    :param operation_type: (:attr:`operation_type`) 
    :type operation_type: 
    
    
    :param related_operation_list: (:attr:`related_operation_list`) List of related operations. These are the operations that may need to be accessed along with the current operation in order for certain workflows to succeed.
    :type related_operation_list: 
    
    
    :param associated_endpoint_list: (:attr:`associated_endpoint_list`) List of associated endpoint objects for the operation.
    :type associated_endpoint_list: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'display_name': 'str',
        'description': 'str',
        'entity_type': 'str',
        'client_name': 'str',
        'created_time': 'datetime',
        'last_updated_time': 'datetime',
        'operation_type': 'iam.v4.authz.OperationType',
        'related_operation_list': 'list[str]',
        'associated_endpoint_list': 'list[iam.v4.authz.AssociatedEndpoint]',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'display_name': 'displayName',
        'description': 'description',
        'entity_type': 'entityType',
        'client_name': 'clientName',
        'created_time': 'createdTime',
        'last_updated_time': 'lastUpdatedTime',
        'operation_type': 'operationType',
        'related_operation_list': 'relatedOperationList',
        'associated_endpoint_list': 'associatedEndpointList',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, display_name=None, description=None, entity_type=None, client_name=None, created_time=None, last_updated_time=None, operation_type=None, related_operation_list=None, associated_endpoint_list=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        ExternalizableAbstractModel.__init__(self, ext_id, links, tenant_id, *args, **kwargs)
        self.__display_name = None
        self.__description = None
        self.__entity_type = None
        self.__client_name = None
        self.__created_time = None
        self.__last_updated_time = None
        self.__operation_type = None
        self.__related_operation_list = None
        self.__associated_endpoint_list = None
        self.discriminator = None
        if display_name is not None:
            self.__display_name = display_name
        if description is not None:
            self.__description = description
        if entity_type is not None:
            self.__entity_type = entity_type
        if client_name is not None:
            self.__client_name = client_name
        if created_time is not None:
            self.__created_time = created_time
        if last_updated_time is not None:
            self.__last_updated_time = last_updated_time
        if operation_type is not None:
            self.__operation_type = operation_type
        if related_operation_list is not None:
            self.__related_operation_list = related_operation_list
        if associated_endpoint_list is not None:
            self.__associated_endpoint_list = associated_endpoint_list

    def _initialize_object_type(self):
        return 'iam.v4.authz.Operation'

    def _initialize_object_version(self):
        return 'v4.r0'


    @property
    def display_name(self):
        """
        Name of the operation.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__display_name

    @display_name.setter
    def display_name(self, display_name):
        if display_name is not None and len(display_name) > 255:
            raise ValueError("Invalid value for `display_name`, length must be less than or equal to `255`")  # noqa: E501
        if display_name is not None and len(display_name) < 1:
            raise ValueError("Invalid value for `display_name`, length must be greater than or equal to `1`")  # noqa: E501
        if display_name is not None and not re.search('^[^<>;\'()&+%\/\\\\\"`]*$', display_name):  # noqa: E501
            raise ValueError(r"Invalid value for `display_name`, must be a follow pattern or equal to `/^[^<>;'()&+%\/\\\\\"`]*$/`")  # noqa: E501

        self.__display_name = display_name

    @property
    def description(self):
        """
        Description of the operation.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__description

    @description.setter
    def description(self, description):
        if description is not None and len(description) > 1000:
            raise ValueError("Invalid value for `description`, length must be less than or equal to `1000`")  # noqa: E501
        if description is not None and not re.search('^[^<>;()&+%\/\\\\\"`]*$', description):  # noqa: E501
            raise ValueError(r"Invalid value for `description`, must be a follow pattern or equal to `/^[^<>;()&+%\/\\\\\"`]*$/`")  # noqa: E501

        self.__description = description

    @property
    def entity_type(self):
        """
        Type of entity associated with this operation.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__entity_type

    @entity_type.setter
    def entity_type(self, entity_type):
        if entity_type is not None and not re.search('^[^<>;\'()&+%\/\\\\\"`]*$', entity_type):  # noqa: E501
            raise ValueError(r"Invalid value for `entity_type`, must be a follow pattern or equal to `/^[^<>;'()&+%\/\\\\\"`]*$/`")  # noqa: E501

        self.__entity_type = entity_type

    @property
    def client_name(self):
        """
        Client that created the entity.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__client_name

    @client_name.setter
    def client_name(self, client_name):
        if client_name is not None and len(client_name) > 255:
            raise ValueError("Invalid value for `client_name`, length must be less than or equal to `255`")  # noqa: E501
        if client_name is not None and not re.search('^[^<>;\'()&+%\/\\\\\"`]*$', client_name):  # noqa: E501
            raise ValueError(r"Invalid value for `client_name`, must be a follow pattern or equal to `/^[^<>;'()&+%\/\\\\\"`]*$/`")  # noqa: E501

        self.__client_name = client_name

    @property
    def created_time(self):
        """
        The creation time of the operation.

        :type:
                :class:`~datetime`
        """  # noqa: E501
        return self.__created_time

    @created_time.setter
    def created_time(self, created_time):

        self.__created_time = created_time

    @property
    def last_updated_time(self):
        """
        The time when the operation was last updated.

        :type:
                :class:`~datetime`
        """  # noqa: E501
        return self.__last_updated_time

    @last_updated_time.setter
    def last_updated_time(self, last_updated_time):

        self.__last_updated_time = last_updated_time

    @property
    def operation_type(self):
        """
        

        :type:
            :class:`~ntnx_iam_py_client.models.iam.v4.authz.OperationType`
        """  # noqa: E501
        return self.__operation_type

    @operation_type.setter
    def operation_type(self, operation_type):

        self.__operation_type = operation_type

    @property
    def related_operation_list(self):
        """
        List of related operations. These are the operations that may need to be accessed along with the current operation in order for certain workflows to succeed.

        :type:
            list[ :class:`~str` ]
        """  # noqa: E501
        return self.__related_operation_list

    @related_operation_list.setter
    def related_operation_list(self, related_operation_list):

        self.__related_operation_list = related_operation_list

    @property
    def associated_endpoint_list(self):
        """
        List of associated endpoint objects for the operation.

        :type:
             list[ :class:`~ntnx_iam_py_client.models.iam.v4.authz.AssociatedEndpoint` ]
        """  # noqa: E501
        return self.__associated_endpoint_list

    @associated_endpoint_list.setter
    def associated_endpoint_list(self, associated_endpoint_list):

        self.__associated_endpoint_list = associated_endpoint_list

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(Operation, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Operation):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

